{ pkgs, ... }:

let
  dgn-lib = import ../lib/trivial.nix;

  dgn-members = (import ../meta).members.groups.iso;
in

{
  imports = [ ./dgn-install ];

  boot = {
    blacklistedKernelModules = [ "snd_pcsp" ];
    kernelPackages = pkgs.linuxPackages_6_1;
    tmp.cleanOnBoot = true;

    loader = {
      systemd-boot.enable = true;
      efi.canTouchEfiVariables = true;
    };

    supportedFilesystems = [
      "exfat"
      "zfs"
    ];
  };

  console.keyMap = "fr";

  services = {
    openssh.enable = true;
  };

  users.users.root.openssh.authorizedKeys.keyFiles =
    builtins.map (m: dgn-lib.mkRel ../keys "${m}.keys") dgn-members;
}
