{ pkgs, ... }:

let
  substitutions = {
    inherit (pkgs)
      bash
      colmena
      coreutils
      git;
  };

  mkShellScript = name: (pkgs.substituteAll ({
    inherit name;
    src = ./. + "/${name}.sh";
    dir = "/bin/";
    isExecutable = true;

    checkPhase = ''
      ${pkgs.stdenv.shellDryRun} "$target"
    '';
  } // substitutions));

  scripts = [
    "ns-update"
    # "mk-backup-key"
    # "wg-setup"
  ];
in

builtins.map mkShellScript scripts
